### Imports ###

# ES			Primary ES-Class
import es

# Playerlib		Manage Players
import playerlib

# Popuplib		Show Popups
import popuplib

# Cmdlib		Run/register/manage Commands
import cmdlib

# Weaponlib		Refill ammo
import weaponlib

#Gamethread		Delayed respawning
import gamethread

#SPE			Respawning
from spe.games import cstrike
import spe

#Random			Generate Random userids for the Boss enemies
import random


### Define Addon Info:
info = es.AddonInfo() 
info.name     = "Last Stand" 
info.version  = "0.1" 
info.url      = "" 
info.basename = "Last_stand" 
info.author   = "Random, Thanks to TodDerEngel"
### Global Vars ###


#User defined CFG Var:
weapon_restricts = {'wave1':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave2':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave3':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave4':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave5':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave6':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave7':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_xm1014,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave8':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave9':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave10':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave11':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave12':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave13':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552,weapon_m249',
					'wave14':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552',
					'wave15':'weapon_glock,weapon_usp,weapon_p228,weapon_fiveseven,weapon_m3,weapon_mac10,weapon_tmp,weapon_mp5navy,weapon_ump45,weapon_galil,weapon_famas,weapon_ak47,weapon_m4a1,weapon_scout,weapon_sg550,weapon_aug,weapon_g3sg1,weapon_sg552',
					'wave16':'glock,usp,p228,elite,fiveseven,m3,mac10,tmp,mp5navy,ump45,UMP45,p90,galil,famas,ak47,m4a1,scout,s550,aug,,g3sg1,sg552,m249',
					'wave17':'glock,usp,p228,elite,fiveseven,m3,mac10,tmp,mp5navy,ump45,UMP45,p90,galil,famas,ak47,m4a1,scout,s550,aug,,g3sg1,sg552,m249',
					'wave18':'',
					'wave19':'',
					'wave20':''}

# Cfg Vars
laststand 					= es.ServerVar("last_stand",			1,	"Enable or disable Last Stand")
enemies 					= es.ServerVar("ls_enemie_count",		32,	"The count of enemies for the squad")
squad						= es.ServerVar("ls_squad_count",		5,	"The count of squad members")
squad_hp					= es.ServerVar("ls_squad_hp",			100,"The HP of the squad members")
enemie_start_hp				= es.ServerVar("ls_enemie_hp",			100,"The HP of the first wave of the enemies")
enemie_hp_increase			= es.ServerVar("ls_enemie_hp_increase",	100,"How much hp get the enemies per wave more")
max_wave					= es.ServerVar("ls_max_wave",			10,	"The last wave")
swap_to_spec				= es.ServerVar("ls_swap_spec_only",		0,	"Swap to many players only to spectator")
respawn_after				= es.ServerVar("ls_respawn",			20,	"After X kills respawn the dead T's and start a wave, Maximal enemie_count - 1")
give_nades					= es.ServerVar("ls_give_nades",			1,	"Give 1 He and 1 flashbang to the ct's")
debug						= es.ServerVar("ls_debug",				1,	"Log all actions")
ammo_refill					= es.ServerVar("ls_ammo_refill",		1,	"Refill the players ammo if it is empty")
# Vars
last_wave = 0
enemies_remaining = respawn_after
enemie_wave = 1
enemie_hp = enemie_start_hp
weapon_menu = 0
weapon_menu_s = 0
added_hp = 0
boss_list = {}

def primary_selected(userid,choice,popupname) :
	global weapon_menu_s
	if debug == 1 :
		es.log(1,'[LastStand]Primary select menu (uid: %s)' % (str(userid)))
	if not popupname == 'primary_select' :
		return False
	else :
		ply = playerlib.getPlayer(userid)
		es.server.queuecmd('es_xgive %s %s' % (userid,choice))
		es.fire("initialize","ls_pweapon_popup_close")
		es.fire("setstring","ls_pweapon_popup_close","weapon",choice)
		es.fire("setstring","ls_pweapon_popup_close","userid",str(userid))
		es.fire("setstring","ls_pweapon_popup_close","name",ply.name)
		es.fire("fire","ls_pweapon_popup_close")
		weapon_menu_s.send(userid)
		es.fire("initialize","ls_sweapon_popup_open")
		es.fire("setstring","ls_sweapon_popup_open","userid",str(userid))
		es.fire("setstring","ls_sweapon_popup_open","name",ply.name)
		es.fire("fire","ls_sweapon_popup_open")
		if debug == 1 :
			es.log(1,'[LastStand]Primary select menu close (uid: %s)' % (str(userid)))
		
def secondary_selected(userid,choice,popupname) :
	if debug == 1 :
		es.log(1,'[LastStand]Secondary select menu (uid: %s)' % (str(userid)))
	if not popupname == 'secondary_select' :
		return False
	else :
		ply = playerlib.getPlayer(userid)
		es.server.queuecmd('es_xgive %s %s' % (userid,choice))
		es.fire("initialize","ls_sweapon_popup_close")
		es.fire("setstring","ls_sweapon_popup_close","weapon",choice)
		es.fire("setstring","ls_sweapon_popup_close","userid",str(userid))
		es.fire("setstring","ls_sweapon_popup_close","name",ply.name)
		es.fire("fire","ls_sweapon_popup_close")
		if give_nades == 1 :
			es.server.queuecmd('es_xgive %s weapon_hegrenade;es_xgive %s weapon_flashbang;es_xgive %s weapon_flashbang' % (userid,userid,userid))
			es.fire("initialize","ls_give_grenade")
			es.fire("setstring","ls_give_grenade","userid",str(userid))
			es.fire("setstring","ls_give_grenade","name",ply.name)
			es.fire("fire","ls_give_grenade")
		if debug == 1 :
			es.log(1,'[LastStand]Secondary select menu close (uid: %s)' % (str(userid)))
		
def create_popups(enemie_wave) :
	global weapon_menu
	global weapon_menu_s
	global weapon_restricts
	if debug == 1 :
		es.log(1,'[LastStand]create_popups called')
	weapon_menu = popuplib.easymenu("primary_select",None,primary_selected)
	weapon_menu_s = popuplib.easymenu("secondary_select",None,secondary_selected)
	weapon_menu.settitle("Select your Primary Weapon")
	weapon_menu_s.settitle("Select your Secondary Weapon")
	enemie_wave = 'wave%s' % (enemie_wave)
	rw = weapon_restricts[enemie_wave]
	weapon_sg = {'weapon_m3':'M3 Shotgun','weapon_xm1014':'XM1014 Shotgun','weapon_mac10':'Mac 10','weapon_tmp':'TMP','weapon_mp5navy':'MP5','weapon_ump45':'UMP45','weapon_p90':'P90','weapon_galil':'Galil','weapon_famas':'Famas','weapon_ak47':'Ak47','weapon_m4a1':'M4A1','weapon_sg550':'SG 550','weapon_aug':'AUG','weapon_scout':'Scout Sniper','weapon_awp':'AWP Sniper','weapon_g3sg1':'G3SG1 Sniper','weapon_sg552':'SG552 Sniper','weapon_m249':'M249'}
	weapon_ids = weapon_sg.keys()
	for wid in weapon_ids :
		wname = weapon_sg[wid]
		if rw.find(wid) == -1 :
			weapon_menu.addoption(wid,wname)
	weapon_secondary = {'weapon_glock':'Glock','weapon_usp':'USP','weapon_p228':'P228','weapon_deagle':'Desert Eagle','weapon_elite':'Elites','weapon_fiveseven':'Five Seven'}
	weapon_ids = weapon_secondary.keys()
	for wid in weapon_ids :
		wname = weapon_secondary[wid]
		if rw.find(wid) == -1 :
			weapon_menu_s.addoption(wid,wname)
	if debug == 1 :
		es.log(1,'[LastStand]create_popups ended')
		

def show_popups() :
	global weapon_menu
	global weapon_menu_s
	if debug == 1 :
		es.log(1,'[LastStand]show_popups called')
	plist = playerlib.getPlayerList('#ct,#alive')
	for ply in plist :
		weapon_menu.send(ply.userid)
		es.fire("initialize","ls_pweapon_popup_open")
		es.fire("setstring","ls_pweapon_popup_open","userid",str(ply.userid))
		es.fire("setstring","ls_pweapon_popup_open","name",ply.name)
		es.fire("fire","ls_pweapon_popup_open")
	if debug == 1 :
		es.log(1,'[LastStand]show_popups ended')

def first_wave() :
	global enemie_wave
	global enemies_remaining
	global last_wave
	global boss_list
	global added_hp
	added_hp = 0
	last_wave = 0
	enemies_remaining = respawn_after
	if debug == 1 :
		es.log(1,'[LastStand]First_wave called')
	enemie_wave = 1
	sort_players()
	if debug == 1 :
		es.log(1,'[LastStand]Sort_players called')
	set_health('squad',1)
	if debug == 1 :
		es.log(1,'[LastStand]Health set squad')
	set_health('enemies',1)
	if debug == 1 :
		es.log(1,'[LastStand]Health set enemies')
	create_popups(1)
	if debug == 1 :
		es.log(1,'[LastStand]Popups created')
	show_popups()
	if debug == 1 :
		es.log(1,'[LastStand]Popups showed')
	es.centermsg('First wave started')
	es.fire("initialize","ls_firt_wave")
	es.fire("setint","ls_first_wave","respawn",respawn_after)
	es.fire("setint","ls_first_wave","squadcount",squad)
	es.fire("setint","ls_first_wave","enemiecount",enemies)
	es.fire("fire","ls_first_wave")
	if debug == 1 :
		es.log(1,'[LastStand]Wave start ended')

def new_wave() :
	global last_wave
	global enemie_wave
	global enemies_remaining
	global bosses
	global boss_list
	if debug == 1 :
		es.log(1,'[LastStand]New wave called (oldwave: %s, enemies_remaining: %s')
	if last_wave == 0 :
		if debug == 1 :
			es.log(1,'[LastStand]Last wave = 0')
		t_list = playerlib.getPlayerList('#t,#dead')
		t_count = 0
		for t in t_list :
			t_count += 1
		respawn_five()
		if debug == 1 :
			es.log(1,"[LastStand]T's respawned")
		enemie_wave = enemie_wave + 1
		set_health('squad',enemie_wave)
		set_health('enemies',enemie_wave)
		if debug == 1 :
			es.log(1,'[LastStand]Health set')
		enemies_remaining = respawn_after
		es.centermsg('Wave %s started' % (enemie_wave))
		create_popups(enemie_wave)
		if debug == 1 :
			es.log(1,'[LastStand]Popups created')
		show_popups()
		if debug == 1 :
			es.log(1,'[LastStand]Popups showd')
		if enemie_wave == max_wave :
			enemies_remaining = enemies
			last_wave = 1
			es.fire("initialize","ls_last_wave_start")
			es.fire("setint","ls_last_wave_start","wavenumber",enemie_wave)
			es.fire("fire","ls_last_wave_start")
		es.fire("initialize","ls_wave_start")
		es.fire("setint","ls_wave_start","wavenumber",enemie_wave)
		es.fire("fire","ls_wave_start")
	else :
		plist = playerlib.getPlayerList("#ct,#alive")
		ct_count = 0
		for ply in plist :
			ct_count += 1
		es.centermsg('Last wave ended, Squad won')
		es.fire("initialize","ls_last_wave_ended")
		es.fire("setint","ls_last_wave_ended","t_left",0)
		es.fire("setint","ls_last_wave_ended","ct_left",ct_count)
		es.fire("setint","ls_last_wave_ended","ct_win",1)
		es.fire("fire","ls_last_wave_ended")

def respawn_five() :
	t_count = 0
	t_list = playerlib.getPlayerList("#t,#dead")
	if t_list == 0 :
		return True
	for t in t_list :
		if t_count >= 5 :
			gamethread.delayed(1,respawn_five)
			return True
		cstrike.respawn(t.userid)
		t_count = t_count + 1
	
## Passt die Lebenspunkte der aktuellen Welle an
def set_health(team,round) :
	global added_hp
	if debug == 1 :
		es.log(1,'[LastStand]Set health called')
	bosses = 0
	team = str(team)
	if team == 'squad' :
		if debug == 1 :
			es.log(1,'[LastStand]Team = squad')
		members = playerlib.getPlayerList('#ct,#alive')
		for ct in members :
			ct.setHealth(squad_hp)
		if debug == 1 :
			es.log(1,'[LastStand]Health set (set_health) ended')	
		return 1
	if team == 'enemies' :
		if debug == 1 :
			es.log(1,"[LastStand]Team = 'enemies'")
		members = playerlib.getPlayerList('#t,#alive')
		if round == 1 :
			for t in members :
				t.setHealth(enemie_start_hp)
		else :
			added_hp = added_hp + enemie_hp_increase
			for t in members :
				new_health = int(enemie_start_hp + added_hp )
				t.setHealth(new_health)
		if debug == 1 :
			es.log(1,'[LastStand]set_health ended')
		return 1
	return 0

## Sortiert die Spieler ein
def sort_players() :
	if debug == 1 :
		es.log(1,'[LastStand]Sort_players called')
	# Zahl der Ts
	t_count = 0
	# ID's der Ts die das Team wechseln
	t_move = []
	# ID's der CTs die das Team wechseln
	ct_move = []
	#Die Spielerliste der T's
	t_list = playerlib.getPlayerList('#t')
	
	#Spielerliste auslesen, wenn der Spieler zu viel ist wird er auf die Wechseliste gesetzt
	for t in t_list :
		t_count += 1
		if t_count > enemies :
			t_count -= 1
			t_move.append(t.userid) 
		
	#Wie bei T's
	ct_list = playerlib.getPlayerList('#ct')
	ct_count = 0
	for ct in ct_list :
		ct_count += 1
		if ct_count > squad :
			ct_count -= 1
			ct_move.append(ct.userid)
	if debug == 1 :
		es.log(1,"[LastStand]T's and CT's counted")
	
	#Die Spieler wechseln bis beide Teams voll sind dann 
	m_to_ct = 0
	m_to_t = 0
	m_to_s = 0
	for uid in t_move :
		if ct_count < squad and swap_to_spec == 0 :
			es.changeteam(uid,3)
			m_to_ct = m_to_ct + 1
			ct_count += 1
		else :
			es.changeteam(uid,1)
			m_to_s = m_to_s +1
	for uid in ct_move :
		if t_count < enemies and swap_to_spec == 0 :
			es.changeteam(uid,2)
			m_to_t = m_to_t + 1
			t_count += 1
		else :
			es.changeteam(uid,1)
			m_to_s = m_to_s + 1
	es.fire("initialize","ls_players_sorted")
	es.fire("setint","ls_players_sorted","swappedtot",m_to_t)
	es.fire("setint","ls_players_sorted","swappedtoct",m_to_ct)
	es.fire("setint","ls_players_sorted","swappedtospec",m_to_s)
	es.fire("fire","ls_players_sorted")
	if debug == 1 :
		es.log(1,'[LastStand]Sort_players ended')

def client_cmd(userid,args) :
	global enemie_wave
	global weapon_restricts
	if debug == 1 :
		es.log(1,'[LastStand]Client_cmd called')
	ply = playerlib.getPlayer(userid)
	if ply.teamid == 2 :
		if debug == 1 :
			es.log(1,'[LastStand]Client_cmd teamid = 2')
		return False
	else :
		if debug == 1 :
			es.log(1,'[LastStand]Client_cmd teamid = other')
		if args[0].lower() == 'buy' :
			enemie_wave2 = 'wave%s' % (enemie_wave)
			rw = weapon_restricts[enemie_wave2]
			if not rw.find('weapon_%s' % (args[1])) == -1 :
				es.tell(userid,"U can't buy %s" % (args[1]))
				if debug == 1 :
					es.log(1,'[LastStand]Client_cmd Buy blocked')
				return False
			else :
				if debug == 1 :
					es.log(1,'[LastStand]Client_cmd Buy allowed')
				return True
		else :
			if debug == 1 :
				es.log(1,'[LastStand]Client_cmd Command not buy')
			return True

### Events
def load() :
	global enemies_remaining
	if debug == 1 :
		es.log(1,'[LastStand]Loaded')
	if int(laststand) > 1 :
		es.loadevents("declare","%s/events.res" % (es.getAddonPath("laststand")))
		es.loadevents("%s/events.res" % (es.getAddonPath("laststand")))
		enemies_remaining = respawn_after
		es.addons.registerClientCommandFilter(client_cmd)
		sort_players()
		es.server.queuecmd('endround')
		set_health('squad',1)
		set_health('enemies',1)
		first_wave()

def player_death(ev) :
	global enemies_remaining
	if int(laststand) <= 0:
		return
	else :
		if debug == 1 :
			es.log(1,'[LastStand]Player_death called')
		ply = playerlib.getPlayer(ev['userid'])
		ply2 = playerlib.getPlayer(ev['attacker'])
		if ply.teamid == 3 :
			if ply2.teamid == 2 :
				byenemie = 1
			else :
				byenemie = 0
			es.fire("initialize","ls_squadmember_death")
			es.fire("setstring","ls_squadmember_death","userid",ev['userid'])
			es.fire("setstring","ls_squadmember_death","name",ply.name)
			es.fire("setint","ls_squadmember_death","bot",ply.isbot)
			es.fire("setint","ls_squadmember_death","byenemie",byenemie)
			es.fire("setstring","ls_squadmember_death","weapon",ev['weapon'])
			es.fire("fire","ls_squadmember_death")
			return
		if debug == 1 :
			es.log(1,'[LastStand]Player_death Teamid searched')
		enemies_remaining = enemies_remaining - 1
		if debug == 1 :
			es.log(1,'[LastStand]Enemies_remaining is now %s' % (enemies_remaining) )
		if enemies_remaining <= 0 :
			if debug == 1 :
				es.log(1,'[LastStand]Player_death called new_wave()')
			new_wave()
		if ply2.teamid == 3 :
			bysquad = 1
		else :
			bysquad = 0
		es.fire("initialize","ls_enemie_death")
		es.fire("setstring","ls_enemie_death","userid",ev['userid'])
		es.fire("setstring","ls_enemie_death","name",ply.name)
		es.fire("setstring","ls_enemie_death","weapon",ev['weapon'])
		es.fire("setint","ls_enemie_death","bot",int(ply.isbot))
		es.fire("setint","ls_enemie_death","bysquad",bysquad)
		es.fire("fire","ls_enemie_death")

def round_start(ev) :
	if laststand <= 0:
		return
	es.server.queuecmd('exec laststand.cfg')
	if debug == 1 :
		es.log(1,'[LastStand]Round start')
	first_wave()

def player_team(ev) :
	if int(laststand) <= 0:
		return
	if debug == 1 :
		es.log(1,'[LastStand]player_team called (uid = %s)' % ev['userid'])
	ply_list = playerlib.getPlayerList('#t')
	t_count = 0
	t_bot = 0
	if debug == 1 :
		es.log(1,'[LastStand]player_team bot check started')
	for ply in ply_list :
		if ply.isbot :
			t_bot = 1
		t_count += 1
	list2 = playerlib.getPlayerList('#ct')
	ct_count = 0
	ct_bot = 0
	for ply in list2 :
		if ply.isbot :
			ct_bot = 1
		ct_count += 1	
	if debug == 1 :
		es.log(1,'[LastStand]player_team bot check ended, result  t = %s ct = %s ' % (t_bot,ct_bot) )
	
	if int(ev['team']) == 2 :
		if debug == 1 :
			es.log(1,'[LastStand]player_team Team = t')
		if ct_bot == 1 :
			es.server.queuecmd('bot_kick t')
			if debug == 1 :
				es.log(1,'[LastStand]player_team bot kicked')
			return
		if t_count >= enemies :
			if swap_to_spec or ct_count >= squad :
				team = 1
				es.changeteam(ev['userid'],1)
				if debug == 1 :
					es.log(1,'[LastStand]player_team Swapped to spec')
			else :
				team = 3
				es.changeteam(ev['userid'],3)
				if debug == 1 :
					es.log(1,'[LastStand]player_team Swapped to ct')
			ply = playerlib.getPlayer(ev['userid'])
			es.fire("initialize","ls_team_blocked")
			es.fire("setstring","ls_team_blocked","userid",ev['userid'])
			es.fire("setstring","ls_team_blocked","name",ply.name)
			es.fire("setint","ls_team_blocked","teamwanted",int(ev['team']))
			es.fire("setint","ls_team_blocked","oldteam",int(ev['oldteam']))
			es.fire("setint","ls_team_blocked","newteam",team)
			es.fire("fire","ls_team_blocked")
			return
	
	if int(ev['team']) == 3 :
		if debug == 1 :
			es.log(1,'[LastStand]player_team Team = ct')
		if ct_bot == 1 :
			if debug == 1 :
				es.log(1,'[LastStand]player_team bot kicked')
			es.server.queuecmd('bot_kick ct')
			return
		if ct_count >= squad :
			if swap_to_spec or t_count >= enemies :
				team = 1
				es.changeteam(ev['userid'],1)
				if debug == 1 :
					es.log(1,'[LastStand]player_team Swapped to spec')
			else :
				team = 2
				es.changeteam(ev['userid'],2)
				if debug == 1 :
					es.log(1,'[LastStand]player_team Swapped to t')
			ply = playerlib.getPlayer(ev['userid'])
			es.fire("initialize","ls_team_blocked")
			es.fire("setstring","ls_team_blocked","userid",ev['userid'])
			es.fire("setstring","ls_team_blocked","name",ply.name)
			es.fire("setint","ls_team_blocked","teamwanted",int(ev['team']))
			es.fire("setint","ls_team_blocked","oldteam",int(ev['oldteam']))
			es.fire("setint","ls_team_blocked","newteam",team)
			es.fire("fire","ls_team_blocked")
			return
	
	if int(ev['team']) == 1 and int(ev['oldteam']) == 2 :
		es.server.queuecmd('bot_add t')
		
	
	if debug == 1 :
		es.log(1,'[LastStand]Nothing swapped')
	ply = playerlib.getPlayer(ev['userid'])
	
	es.fire("initialize","ls_team_allowed")
	es.fire("setstring","ls_team_allowed","userid",ev['userid'])
	es.fire("setstring","ls_team_allowed","name",ply.name)
	es.fire("setint","ls_team_allowed","oldteam",int(ev['oldteam']))
	es.fire("setint","ls_team_allowed","newteam",int(ev['team']))
	es.fire("fire","ls_team_allowed")

def player_spawn(ev) :
	if int(laststand) <= 0 :
		return
	if debug == 1 :
		es.log(1,'[LastStand]player_spawn called')
	es.server.queuecmd('es_xfire %s func_bomb_target Disable' % (ev['userid']))
	es.server.queuecmd('es_xfire %s func_hostage_rescue Disable' % (ev['userid']))
	if debug == 1 :
		es.log(1,'[LastStand]player_team targets disabled')
	if int(ev['es_userteam']) == 2 :
		es.server.queuecmd('es_xfire %s func_buyzone Disable' % (ev['userid']))
		if debug == 1 :
			es.log(1,'[LastStand]player_team Buyzone disabled')

def item_pickup(ev) :
	global enemie_wave
	global weapon_menu
	global weapon_restricts
	if int(laststand) <= 0 :
		return
	if debug == 1 :
		es.log(1,'[LastStand]item_pickup called')
	if int(ev['es_userteam']) == 2 :
		if debug == 1 :
			es.log(1,'[LastStand]item_pickup team = t')
		wlist = spe.getWeaponNameList(ev['userid'])
		weapon_found = False
		for weapon in wlist :
			if not weapon == 'weapon_knife' :
				if debug == 1 :
					es.log(1,'[LastStand]item_pickup Start weapon striping')
				es.server.queuecmd('es_xgive %s player_weaponstrip' % (ev['userid']))
				es.server.queuecmd('es_xfire %s player_weaponstrip strip' % (ev['userid']))
				es.delayed(0.1,'es_xgive %s weapon_knife' % (ev['userid']))
				es.fire("initialize","ls_item_pickup_blocked")
				es.fire("setstring","ls_item_pickup_blocked","userid",ev['userid'])
				es.fire("setstring","ls_item_pickup_blocked","name",ev['es_username'])
				es.fire("setstring","ls_item_pickup_blocked","weapon",weapon)
				es.fire("setint","ls_item_pickup_blocked","weaponmenushowed",0)
				es.fire("fire","ls_item_pickup_blocked")
				weapon_found = True
				if debug == 1 :
					es.log(1,'[LastStand]item_pickup weapons stripped')
		if weapon_found == True :
			es.fire("initialize","ls_item_pickup_allowed")
			es.fire("setstring","ls_item_pickup_allowed","userid",ev['userid'])
			es.fire("setstring","ls_item_pickup_allowed","name",ev['es_username'])
			es.fire("setstring","ls_item_pickup_allowed","weapon",ev['item'])
			es.fire("fire","ls_item_pickup_allowed")
	if int(ev['es_userteam']) == 3 :
		if debug == 1 :
			es.log(1,'[LastStand]item_pickup team = ct')
		enemie_wave2 = 'wave%s' % (enemie_wave)
		rw = weapon_restricts[enemie_wave2]
		weapon_list = spe.getWeaponNameList(ev['userid'])
		weapon_found = False
		for weapon in weapon_list :
			if not rw.find(weapon) == -1 :
				if debug == 1 :
					es.log(1,'[LastStand]item_pickup weapon found')
				es.server.queuecmd('est_RemoveWeapon %s %s' % (ev['userid'],weapon))
				if debug == 1 :
					es.log(1,'[LastStand]item_pickup weapon removed (%s)' % (weapon))
				weapon_found = True
				es.fire("initialize","ls_item_pickup_blocked")
				es.fire("setstring","ls_item_pickup_blocked","userid",ev['userid'])
				es.fire("setstring","ls_item_pickup_blocked","name",ev['es_username'])
				es.fire("setstring","ls_item_pickup_blocked","weapon",weapon)
				es.fire("setint","ls_item_pickup_blocked","weaponmenushowed",1)
				es.fire("fire","ls_item_pickup_blocked")
		if weapon_found == True :
			weapon_menu.send(ev['userid'])
			if debug == 1 :
				es.log(1,'[LastStand]item_pickup Menu showed')
		else :
			es.fire("initialize","ls_item_pickup_allowed")
			es.fire("setstring","ls_item_pickup_allowed","userid",ev['userid'])
			es.fire("setstring","ls_item_pickup_allowed","name",ev['es_username'])
			es.fire("setstring","ls_item_pickup_allowed","weapon",ev['item'])
			es.fire("fire","ls_item_pickup_allowed")

def unload():
	es.addons.unregisterClientCommandFilter(client_cmd)
	if debug == 1 :
		es.log(1,'[LastStand]Unloaded')
	
def weapon_fire_on_empty(ev) :
	if int(laststand) <= 0 or int(ammo_refill) <= 0:
		return
	else :
		if debug == 1 :
			es.log(1,'[LastStand]Ammo refilled')
		weapon = weaponlib.getWeapon(ev['weapon'])
		es.setplayerprop(ev['userid'],weapon.prop,weapon.maxammo)
		es.fire("initialize","ls_ammo_refilled")
		es.fire("setstring","ls_ammo_refilled","userid",ev['userid'])
		es.fire("setstring","ls_ammo_refilled","name",ev['es_username'])
		es.fire("setstring","ls_ammo_refilled","weapon",ev['weapon'])
		es.fire("fire","ls_ammo_refilled")
		
def round_end(ev) :
	if not ev['reason'] == 8 and ev['reason'] == 9 :
		return
	ctwin = 3
	if ev['reason'] == 8 :
		ctwin = 1
	if ev['reason'] == 9 :
		ctwin = 0
	plist = playerlib.getPlayerList("#ct,#alive")
	tlist = playerlib.getPlayerList("#t,#alive")
	
	ct_count = 0
	for ply in plist :
		ct_count += 1
		
	t_count = 0
	for ply in tlist :
		t_count += 1
	
	es.fire("initialize","ls_last_wave_ended")
	es.fire("setint","ls_last_wave_ended","t_left",t_count)
	es.fire("setint","ls_last_wave_ended","ct_left",ct_count)
	es.fire("setint","ls_last_wave_ended","ct_win",ctwin)
	es.fire("fire","ls_last_wave_ended")

def es_map_start(ev):
    es.loadevents("%s/events.res" % (es.getAddonPath("laststand")))